/*
 * softfloat GPL compatible stub
 *
 * Copyright (c) 2014 Alexey Kardashevskiy, IBM Corporation.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License,
 *  or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, see <http//www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>

#define _SYMBOL(name) \
    extern void name(void); \
    void name(void) \
    { \
        fprintf(stderr, #name " is not implemented, aborting\n"); \
        exit(1); \
    }

_SYMBOL(stubfunc32)
_SYMBOL(stubfunc64)
_SYMBOL(helper_stubfunc32)
_SYMBOL(helper_stubfunc64)
_SYMBOL(add128)
_SYMBOL(add192)
_SYMBOL(addFloat128Sigs)
_SYMBOL(addFloat32Sigs)
_SYMBOL(addFloat64Sigs)
_SYMBOL(addFloatx80Sigs)
_SYMBOL(commonNaNToFloat128)
_SYMBOL(commonNaNToFloat16)
_SYMBOL(commonNaNToFloat32)
_SYMBOL(commonNaNToFloat64)
_SYMBOL(commonNaNToFloatx80)
_SYMBOL(countLeadingZeros32)
_SYMBOL(countLeadingZeros64)
_SYMBOL(eq128)
_SYMBOL(estimateDiv128To64)
_SYMBOL(estimateSqrt32)
_SYMBOL(extractFloat128Exp)
_SYMBOL(extractFloat128Frac0)
_SYMBOL(extractFloat128Frac1)
_SYMBOL(extractFloat128Sign)
_SYMBOL(extractFloat16Exp)
_SYMBOL(extractFloat16Frac)
_SYMBOL(extractFloat16Sign)
_SYMBOL(extractFloat32Exp)
_SYMBOL(extractFloat32Frac)
_SYMBOL(extractFloat32Sign)
_SYMBOL(extractFloat64Exp)
_SYMBOL(extractFloat64Frac)
_SYMBOL(extractFloat64Sign)
_SYMBOL(extractFloatx80Exp)
_SYMBOL(extractFloatx80Frac)
_SYMBOL(extractFloatx80Sign)
_SYMBOL(float128_add)
_SYMBOL(float128_compare)
_SYMBOL(float128_compare_internal)
_SYMBOL(float128_compare_quiet)
_SYMBOL(float128_default_nan)
_SYMBOL(float128_div)
_SYMBOL(float128_eq)
_SYMBOL(float128_eq_quiet)
_SYMBOL(float128_is_quiet_nan)
_SYMBOL(float128_is_signaling_nan)
_SYMBOL(float128_le)
_SYMBOL(float128_le_quiet)
_SYMBOL(float128_lt)
_SYMBOL(float128_lt_quiet)
_SYMBOL(float128_maybe_silence_nan)
_SYMBOL(float128_mul)
_SYMBOL(float128_rem)
_SYMBOL(float128_round_to_int)
_SYMBOL(float128_scalbn)
_SYMBOL(float128_sqrt)
_SYMBOL(float128_sub)
_SYMBOL(float128ToCommonNaN)
_SYMBOL(float128_to_float32)
_SYMBOL(float128_to_float64)
_SYMBOL(float128_to_floatx80)
_SYMBOL(float128_to_int32)
_SYMBOL(float128_to_int32_round_to_zero)
_SYMBOL(float128_to_int64)
_SYMBOL(float128_to_int64_round_to_zero)
_SYMBOL(float128_unordered)
_SYMBOL(float128_unordered_quiet)
_SYMBOL(float16_default_nan)
_SYMBOL(float16_is_quiet_nan)
_SYMBOL(float16_is_signaling_nan)
_SYMBOL(float16_maybe_silence_nan)
_SYMBOL(float16ToCommonNaN)
_SYMBOL(float16_to_float32)
_SYMBOL(float16_to_float64)
_SYMBOL(float32_add)
_SYMBOL(float32_compare)
_SYMBOL(float32_compare_internal)
_SYMBOL(float32_compare_quiet)
_SYMBOL(float32_default_nan)
_SYMBOL(float32_div)
_SYMBOL(float32_eq)
_SYMBOL(float32_eq_quiet)
_SYMBOL(float32_exp2)
_SYMBOL(float32_exp2_coefficients)
_SYMBOL(float32_is_any_nan)
_SYMBOL(float32_is_quiet_nan)
_SYMBOL(float32_is_signaling_nan)
_SYMBOL(float32_le)
_SYMBOL(float32_le_quiet)
_SYMBOL(float32_log2)
_SYMBOL(float32_lt)
_SYMBOL(float32_lt_quiet)
_SYMBOL(float32_max)
_SYMBOL(float32_maxnum)
_SYMBOL(float32_maybe_silence_nan)
_SYMBOL(float32_min)
_SYMBOL(float32_minmax)
_SYMBOL(float32_minnum)
_SYMBOL(float32_mul)
_SYMBOL(float32_muladd)
_SYMBOL(float32_rem)
_SYMBOL(float32_round_to_int)
_SYMBOL(float32_scalbn)
_SYMBOL(float32_sqrt)
_SYMBOL(float32_squash_input_denormal)
_SYMBOL(float32_sub)
_SYMBOL(float32ToCommonNaN)
_SYMBOL(float32_to_float128)
_SYMBOL(float32_to_float16)
_SYMBOL(float32_to_float64)
_SYMBOL(float32_to_floatx80)
_SYMBOL(float32_to_int16)
_SYMBOL(float32_to_int16_round_to_zero)
_SYMBOL(float32_to_int32)
_SYMBOL(float32_to_int32_round_to_zero)
_SYMBOL(float32_to_int64)
_SYMBOL(float32_to_int64_round_to_zero)
_SYMBOL(float32_to_uint16)
_SYMBOL(float32_to_uint16_round_to_zero)
_SYMBOL(float32_to_uint32)
_SYMBOL(float32_to_uint32_round_to_zero)
_SYMBOL(float32_to_uint64)
_SYMBOL(float32_to_uint64_round_to_zero)
_SYMBOL(float32_unordered)
_SYMBOL(float32_unordered_quiet)
_SYMBOL(float64_add)
_SYMBOL(float64_compare)
_SYMBOL(float64_compare_internal)
_SYMBOL(float64_compare_quiet)
_SYMBOL(float64_default_nan)
_SYMBOL(float64_div)
_SYMBOL(float64_eq)
_SYMBOL(float64_eq_quiet)
_SYMBOL(float64_is_any_nan)
_SYMBOL(float64_is_quiet_nan)
_SYMBOL(float64_is_signaling_nan)
_SYMBOL(float64_le)
_SYMBOL(float64_le_quiet)
_SYMBOL(float64_log2)
_SYMBOL(float64_lt)
_SYMBOL(float64_lt_quiet)
_SYMBOL(float64_max)
_SYMBOL(float64_maxnum)
_SYMBOL(float64_maybe_silence_nan)
_SYMBOL(float64_min)
_SYMBOL(float64_minmax)
_SYMBOL(float64_minnum)
_SYMBOL(float64_mul)
_SYMBOL(float64_muladd)
_SYMBOL(float64_rem)
_SYMBOL(float64_round_to_int)
_SYMBOL(float64_scalbn)
_SYMBOL(float64_sqrt)
_SYMBOL(float64_squash_input_denormal)
_SYMBOL(float64_sub)
_SYMBOL(float64ToCommonNaN)
_SYMBOL(float64_to_float128)
_SYMBOL(float64_to_float16)
_SYMBOL(float64_to_float32)
_SYMBOL(float64_to_floatx80)
_SYMBOL(float64_to_int16)
_SYMBOL(float64_to_int16_round_to_zero)
_SYMBOL(float64_to_int32)
_SYMBOL(float64_to_int32_round_to_zero)
_SYMBOL(float64_to_int64)
_SYMBOL(float64_to_int64_round_to_zero)
_SYMBOL(float64_to_uint16)
_SYMBOL(float64_to_uint16_round_to_zero)
_SYMBOL(float64_to_uint32)
_SYMBOL(float64_to_uint32_round_to_zero)
_SYMBOL(float64_to_uint64)
_SYMBOL(float64_to_uint64_round_to_zero)
_SYMBOL(float64_trunc_to_int)
_SYMBOL(float64_unordered)
_SYMBOL(float64_unordered_quiet)
_SYMBOL(float_raise)
_SYMBOL(floatx80_add)
_SYMBOL(floatx80_compare)
_SYMBOL(floatx80_compare_internal)
_SYMBOL(floatx80_compare_quiet)
_SYMBOL(floatx80_default_nan)
_SYMBOL(floatx80_div)
_SYMBOL(floatx80_eq)
_SYMBOL(floatx80_eq_quiet)
_SYMBOL(floatx80_is_quiet_nan)
_SYMBOL(floatx80_is_signaling_nan)
_SYMBOL(floatx80_le)
_SYMBOL(floatx80_le_quiet)
_SYMBOL(floatx80_lt)
_SYMBOL(floatx80_lt_quiet)
_SYMBOL(floatx80_maybe_silence_nan)
_SYMBOL(floatx80_mul)
_SYMBOL(floatx80_rem)
_SYMBOL(floatx80_round_to_int)
_SYMBOL(floatx80_scalbn)
_SYMBOL(floatx80_sqrt)
_SYMBOL(floatx80_sub)
_SYMBOL(floatx80ToCommonNaN)
_SYMBOL(floatx80_to_float128)
_SYMBOL(floatx80_to_float32)
_SYMBOL(floatx80_to_float64)
_SYMBOL(floatx80_to_int32)
_SYMBOL(floatx80_to_int32_round_to_zero)
_SYMBOL(floatx80_to_int64)
_SYMBOL(floatx80_to_int64_round_to_zero)
_SYMBOL(floatx80_unordered)
_SYMBOL(floatx80_unordered_quiet)
_SYMBOL(get_float_exception_flags)
_SYMBOL(int32_to_float128)
_SYMBOL(int32_to_float32)
_SYMBOL(int32_to_float64)
_SYMBOL(int32_to_floatx80)
_SYMBOL(int64_to_float128)
_SYMBOL(int64_to_float32)
_SYMBOL(int64_to_float64)
_SYMBOL(int64_to_floatx80)
_SYMBOL(le128)
_SYMBOL(lt128)
_SYMBOL(mul128By64To192)
_SYMBOL(mul128To256)
_SYMBOL(mul64To128)
_SYMBOL(normalizeFloat128Subnormal)
_SYMBOL(normalizeFloat16Subnormal)
_SYMBOL(normalizeFloat32Subnormal)
_SYMBOL(normalizeFloat64Subnormal)
_SYMBOL(normalizeFloatx80Subnormal)
_SYMBOL(normalizeRoundAndPackFloat128)
_SYMBOL(normalizeRoundAndPackFloat32)
_SYMBOL(normalizeRoundAndPackFloat64)
_SYMBOL(normalizeRoundAndPackFloatx80)
_SYMBOL(packFloat128)
_SYMBOL(packFloat16)
_SYMBOL(packFloat32)
_SYMBOL(packFloat64)
_SYMBOL(packFloatx80)
_SYMBOL(pickNaN)
_SYMBOL(pickNaNMulAdd)
_SYMBOL(propagateFloat128NaN)
_SYMBOL(propagateFloat32MulAddNaN)
_SYMBOL(propagateFloat32NaN)
_SYMBOL(propagateFloat64MulAddNaN)
_SYMBOL(propagateFloat64NaN)
_SYMBOL(propagateFloatx80NaN)
_SYMBOL(roundAndPackFloat128)
_SYMBOL(roundAndPackFloat16)
_SYMBOL(roundAndPackFloat32)
_SYMBOL(roundAndPackFloat64)
_SYMBOL(roundAndPackFloatx80)
_SYMBOL(roundAndPackInt32)
_SYMBOL(roundAndPackInt64)
_SYMBOL(roundAndPackUint64)
_SYMBOL(set_float_exception_flags)
_SYMBOL(set_float_rounding_mode)
_SYMBOL(shift128ExtraRightJamming)
_SYMBOL(shift128Right)
_SYMBOL(shift128RightJamming)
_SYMBOL(shift32RightJamming)
_SYMBOL(shift64ExtraRightJamming)
_SYMBOL(shift64RightJamming)
_SYMBOL(shortShift128Left)
_SYMBOL(shortShift192Left)
_SYMBOL(sub128)
_SYMBOL(sub192)
_SYMBOL(subFloat128Sigs)
_SYMBOL(subFloat32Sigs)
_SYMBOL(subFloat64Sigs)
_SYMBOL(subFloatx80Sigs)
_SYMBOL(uint32_to_float32)
_SYMBOL(uint32_to_float64)
_SYMBOL(uint64_to_float128)
_SYMBOL(uint64_to_float32)
_SYMBOL(uint64_to_float64)
